//
//	Cu "wI2cRtc8564" RTC-8856hCo
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//	12/04/14
//
//		wI2c̕pKv
//

#ifndef wI2cRtc8564_h
#define wI2cRtc8564_h

#include <inttypes.h>


// RTCWX^AhX
const uint8_t rgCTRL1 =		0x00;	//
const uint8_t rgCTRL2 =		0x01;	//
const uint8_t rgSEC =		0x02;	//
const uint8_t rgMIN =		0x03;	//
const uint8_t rgHUR =		0x04;	//
const uint8_t rgDAY =		0x05;	//
const uint8_t rgWKDAY =		0x06;	//
const uint8_t rgMONS =		0x07;	//
const uint8_t rgYEAR =		0x08;	//
const uint8_t rgALMMIN =	0x09;	//
const uint8_t rgALMHUR =	0x0A;	//
const uint8_t rgALMDAY =	0x0B;	//
const uint8_t rgALMWKDAY =	0x0C;	//
const uint8_t rgCOFREQ =	0x0D;	//
const uint8_t rgTMCTRL =	0x0E;	//
const uint8_t rgTIMER =		0x0F;	//

#define SlvAdrs		0x51			// I2CX[uAhX
#define CByte		(SlvAdrs << 1)	// Rg[oCg

#define CLKOUT_1Hz		1
#define CLKOUT_32Hz		2
#define CLKOUT_1024Hz	3
#define CLKOUT_32768Hz	4
#define CLKOUT_DISABLE	0



class wI2cRtc8564
{
public:
	wI2cRtc8564(void);							// RXgN^

	void init(void);	// 
	void setDate(uint8_t year, uint8_t mon, uint8_t day, uint8_t wkday, uint8_t bcdflg=true);	// N,j ݒ
	void setTime(uint8_t hur, uint8_t min, uint8_t sec, uint8_t bcdflg=true);	// b ݒ
	void readDate(uint8_t *year, uint8_t *mon, uint8_t *day, uint8_t *wkday, uint8_t bcdflg=true);	// N,j ǂݏo
	void readTime(uint8_t *hur, uint8_t *min, uint8_t *sec, uint8_t bcdflg=true);	// b ǂݏo

	void setAlarm(uint8_t day, uint8_t hur, uint8_t min, uint8_t bcdflg=true);	// A[ ݒ
	void readAlarm(uint8_t *day, uint8_t *hur, uint8_t *min, uint8_t bcdflg=true);	// A[ ݒǏo

	uint8_t checkAlarm(void);	// A[`FbN
	void setClkOut(uint8_t frq);	// NbNo͒[q gݒ
	void AlmEnable(uint8_t wkd, uint8_t day, uint8_t hur, uint8_t min);	// A[Lڂ̐ݒ
	void AlmStop(void);	// A[~
	uint8_t readReg(uint8_t adrs, uint8_t *dat);	// WX^ǂݏo
	uint8_t writeReg(uint8_t adrs, uint8_t dat);	// WX^

	uint8_t BinToBcd(uint8_t num);		// oCiBCD֕ϊ
	uint8_t BcdToBin(uint8_t num);		// BCDoCi֕ϊ

	int slaveAddress;
private:

};

#endif

