//
//
//  ライブラリ "w7S4Led" テストプログラム
//		copyright (c) 2010-2013 T.Nakao    http://www.wsnak.com
//
//    10/05/11 テストプログラム
//

#include <wCTimer.h>
#include <wDisplay.h>


wD7Seg297 D7sLed(1, 2, 3, 4, 5, 6);
wCtcTimer2A tm;

byte SoftCounter = 0;
byte TmgFlag = false;
byte SubCount = 0;
byte Flag1sec = false;

unsigned int DispCount = 0;

// 初期化
void setup(void) {
  tm.init(10);						// 0.064 * 10 = 0.64ms(640us)
  tm.onTimer(OnTimer);    // ハンドラ登録

}


// メインループ
void loop(void) {
	unsigned int val;
	byte i;

	tm.checkTimeup();

	if(Flag1sec) {
		// 約1秒
		Flag1sec = false;

		// 表示データを更新
		val = DispCount;											// カウント値
		for(i = 0; i < 4; i++) {							// 最下位桁から
			D7sLed.digit[3 - i] = (byte)val;
			val >>= 4;													// 次の桁
		}
		DispCount++;
	}
}


// タイマハンドラ(16ms)
void OnTimer(void) {
	D7sLed.process();			// 7SegLED更新処理
	SoftCounter++;
	if(SoftCounter == 125) {
		// 0.64ms * 125 = 80ms
		SubCount++;
		if(SubCount == 12) {
			SubCount = 0;
			Flag1sec = true;			// 約1秒
		}
		SoftCounter = 0;
	}
}
