//
//  I2C制御 4桁7セグメントLEDコントローラ テスト (I2Cマスタ)
//    ドライバwI2cD7S4Ledの動作確認用
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//
//    12/05/12 (c)T.Nakao
//

#include <Wire.h>     // I2C
#include <wDisplay.h> // 7セグメントLEDドライバ

wI2cD7S4Led d7sled;   // I2C化7セグメントLED インスタンス


// 初期化
void setup(void) {

  Wire.begin();
  d7sled.begin(0x10);     // I2Cアドレス

  // ゼロサプレス、数値表示のテスト
  d7sled.putNumber(0);    // 数値表示
  delay(1000);
  d7sled.zeroPadding();
  delay(1000);
  d7sled.noZeroPadding();
  delay(1000);
  d7sled.zeroPadding();
  delay(1000);

  d7sled.putNumber(101);  // 数値表示
  delay(1000);
  d7sled.zeroPadding();
  delay(1000);
  d7sled.noZeroPadding();
  delay(1000);
  d7sled.zeroPadding();
  delay(1000);

  d7sled.putNumber(123);  // 数値表示
  delay(500);

  // 小数点表示のテスト
  d7sled.setDP(1);
  delay(500);
  d7sled.setDP(2);
  delay(500);
  d7sled.setDP(3);
  delay(500);
  d7sled.setDP(4);
  delay(500);
  d7sled.setDP(0);
  delay(500);

  // 表示切り替えのテスト
  d7sled.noDisplay();
  delay(500);
  d7sled.display();
  delay(500);

  // 1桁表示のテスト
  byte i, j;
  for(j = 0; j < 4; j++) {    // 桁番号
    for(i = 0; i < 17; i++) {
      d7sled.putDigit(j, i);
      delay(500);
    }
  }

}

// メインループ
void loop(void) {

}
