//
//	Cu "wB10Led"
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//		10/05/20 WSN296 10o[LEDphCo (DBGς)
//


#include <avr/io.h>
#include "wB10Led.h"

#include "arduino.h"



//---------------------------------------------------
//	RXgN^
//---------------------------------------------------
wB10Led::wB10Led(uint8_t ck, uint8_t di, uint8_t lt) {
	pinCk = ck;
	pinDi = di;
	pinLt = lt;

	pinMode(pinCk, OUTPUT);
	pinMode(pinDi, OUTPUT);
	pinMode(pinLt, OUTPUT);

	digitalWrite(pinCk, LOW);
	digitalWrite(pinLt, LOW);

	srSet16bit(0);

	levelRvs = false;			// o[Lk E

#ifdef DDD
	level[0] = 0x0000;
	level[1] = 0x0001;
	level[2] = 0x0003;
	level[3] = 0x0007;
	level[4] = 0x000F;
	level[5] = 0x001F;
	level[6] = 0x003F;
	level[7] = 0x007F;
	level[8] = 0x00FF;
	level[9] = 0x01FF;
	level[10] = 0x03FF;
#endif
}


//---------------------------------------------------
// 10rbg oCi\ib0`b9j
//---------------------------------------------------
void wB10Led::writeBin(uint16_t data10) {
	uint16_t wdat;

	wdat = outBuf & 0xFC00;
	wdat |= (data10 & 0x03FF);

	srSet16bit(wdat);
}


//---------------------------------------------------
// LEDOib10`b15j̃|[go
//---------------------------------------------------
void wB10Led::writeExtByte(uint8_t data6) {
	uint16_t wdat;

	wdat = outBuf & 0x03FF;
	wdat |= ((uint16_t)data6 << 10);

	srSet16bit(wdat);
}



//---------------------------------------------------
// x[^\(0-10)
//---------------------------------------------------
void wB10Led::wirteLevel(uint8_t val) {
	uint16_t wdat;
	uint8_t i;

	if(val == 0) {
		wdat = 0;
	} else if(val < 11) {
		// 1..10
		wdat = 0;

		if(!levelRvs) {
			for(i = 0; i < val - 1; i++) {
				wdat |= 0x0200;
				wdat >>= 1;
			}
			wdat |= 0x0200;
        } else {
			for(i = 0; i < val - 1; i++) {
				wdat |= 1;
				wdat <<= 1;
			}
			wdat |= 1;
		}
	} else {
		return;			// l
	}

	srSet16bit(wdat);


#ifdef DDD
	if(data < 11) {
		wdat = outBuf & 0xFC00;
		wdat |= level[data];

		srSet16bit(wdat);
	}
#endif
}



//---------------------------------------------------
// rbg(1rbgƂɃZbg/Zbg)
//---------------------------------------------------
void wB10Led::writeBit(uint8_t bit_num, uint8_t hi) {
	uint16_t wdat, pat;

	wdat = outBuf;
	pat = 1 << bit_num;
	if(hi) {
		// high
		wdat |= pat;
	} else {
		// low
		wdat &= ~pat;
	}
	srSet16bit(wdat);
}


//---------------------------------------------------
// 16rbg VtgWX^ݒ
//---------------------------------------------------
void wB10Led::srSet16bit(uint16_t val) {
	uint8_t i;

	outBuf = val;
	for(i = 0; i < 16; i++) {
		if(val & 0x8000) {		// ŏʃrbg𔻒
			// 1
			digitalWrite(pinDi, HIGH);
		} else {
			// 0
			digitalWrite(pinDi, LOW);
		}
		// VtgNbN
		digitalWrite(pinCk, HIGH);
		val <<= 1;				// ̃rbg
		digitalWrite(pinCk, LOW);
	}
	// b`pX
	digitalWrite(pinLt, HIGH);

	digitalWrite(pinLt, LOW);
}

