//
//	I2C 47ZOgLEDhCo
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//		12/05/11
//
//		WireƕpKv
//

#include "wI2cD7S4Led.h"
#include "Wire.h"
#include "Arduino.h"


// RXgN^
wI2cD7S4Led::wI2cD7S4Led(void) {

}


void wI2cD7S4Led::begin(uint8_t adrs) {
	setSlvAddress(adrs);
}

void wI2cD7S4Led::setSlvAddress(uint8_t adrs) {
	_myAddress = adrs;
}


void wI2cD7S4Led::init(void) {

}


void wI2cD7S4Led::zeroPadding(void) {
	uint8_t cmd;
	uint8_t para;

	Wire.beginTransmission(_myAddress);
	cmd = 0x81;
	Wire.write(cmd);
	para = 1;
	Wire.write(para);
	Wire.endTransmission();
}

void wI2cD7S4Led::noZeroPadding(void) {
	uint8_t cmd;
	uint8_t para;

	Wire.beginTransmission(_myAddress);
	cmd = 0x81;
	Wire.write(cmd);
	para = 0;
	Wire.write(para);
	Wire.endTransmission();
}


void wI2cD7S4Led::display(void) {
	uint8_t cmd;
	uint8_t para;

	Wire.beginTransmission(_myAddress);
	cmd = 0x82;
	Wire.write(cmd);
	para = 1;
	Wire.write(para);
	Wire.endTransmission();
}

void wI2cD7S4Led::noDisplay(void) {
	uint8_t cmd;
	uint8_t para;

	Wire.beginTransmission(_myAddress);
	cmd = 0x82;
	Wire.write(cmd);
	para = 0;
	Wire.write(para);
	Wire.endTransmission();
}


// 1\(hexaA}CiX)
void wI2cD7S4Led::putDigit(uint8_t dg, uint8_t num) {
	uint8_t cmd = 0x88;

	cmd |= (dg & 0x03);
	if(num > 17) {
		num = 17;
	}
	Wire.beginTransmission(_myAddress);
	Wire.write(cmd);
	Wire.write(num);
	Wire.endTransmission();
}


//
// ő4 10i\
//
void wI2cD7S4Led::putNumber(int num) {
	uint8_t numH, numL;
//	char dig[4];
	uint8_t i;

	if(num > 10000) {
		num = 0;
	}

	numH = (uint8_t)(num >> 8);			// 
	numL = (uint8_t)(num & 0x00FF);		// 

	Wire.beginTransmission(_myAddress);
	Wire.write(numH);
	Wire.write(numL);
	Wire.endTransmission();


//	dig[3] = num / 1000;		// 1000̌
//	num = num % 1000;
//	dig[2] = num / 100;			// 100̌
//	num = num % 100;
//	dig[1] = num / 10;			// 10̌
//	dig[0] = num % 10;			// 1̌

//	Wire.beginTransmission(_myAddress);
//	cmd = 0x00;
//	Wire.write(cmd);
//	for(i = 0; i < 4; i++) {
//		Wire.write(dig[i]);
//	}
//	Wire.endTransmission();
}


//
// _ݒ
//
void wI2cD7S4Led::setDP(uint8_t dp) {
	uint8_t cmd;
	uint8_t para;

	if(dp == 0 || dp > 4) {
		// _\Ȃ
		para = 0;
	} else {
		para = 1;
		para <<= (dp - 1);
	}

	Wire.beginTransmission(_myAddress);
	cmd = 0x80;
	Wire.write(cmd);
	Wire.write(para);
	Wire.endTransmission();
}
