//
//	I2CLCDhCo (ėp I2CLCDAACM1602, 40x4s)
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//		WireƕpKv
//
//		12/04/26
//		12/05/09 40x4Ή setCursor(x,y,a), selectArea(a) ǉȂ
//

#include "wI2cLcd.h"
#include "Wire.h"
#include "Arduino.h"


// RXgN^
wI2cLcd::wI2cLcd(uint8_t bm8) {
	_bitmode = bm8;			// rbg[h 8/4
	_w_area = false;
	initFlag = true;
	currArea = 9;
}


// ʏAgȂ
void wI2cLcd::init(void) {
	begin(16, 2);
}


void wI2cLcd::begin(uint8_t cols, uint8_t lines, uint8_t adrs) {
	slaveAddress = adrs;			// I2CX[uAhX

	if((cols >= 40) && (lines >= 4)) {
		// 40x4
		_displayfunction |= LCD_2LINE;
		lines = 2;							// s␳ 2sx2ƂĈ
		_w_area = true;
	} else if (lines > 1) {
		_displayfunction |= LCD_2LINE;
	}

	_numlines = lines;						// s

	_displaycontrol = LCD_DISPLAYON | LCD_CURSOROFF | LCD_BLINKOFF;
	_displaymode = LCD_ENTRYLEFT | LCD_ENTRYSHIFTDECREMENT;

	if(initFlag) {
		if(_w_area) {
			selectArea(2);		// GAI
		}

		delayMicroseconds(15000);
		writeCmd(0x01);
		delayMicroseconds(5000);

		if(_bitmode == LCD_8BITMODE) {
			// 8bit mode
			writeCmd(0x38);
		} else {
			// 4bit mode
			writeCmd(0x28);
		}

		delayMicroseconds(5000);
		writeCmd(0x0f);
		delayMicroseconds(5000);
		writeCmd(0x06);
		delayMicroseconds(5000);

		display();
		clear();
	}

	if(_w_area) {
		selectArea(0);			// GA0I
	}
}


void wI2cLcd::clear(void)
{
	writeCmd(LCD_CLEARDISPLAY);
	delayMicroseconds(2000);
}

void wI2cLcd::home(void)
{
	writeCmd(LCD_RETURNHOME);
	delayMicroseconds(2000);
}


void wI2cLcd::setCursor(uint8_t col, uint8_t row)
{
	if(row > 3) {
		row = 3;
	}
	int row_offsets[] = { 0x00, 0x40, 0x14, 0x54 };
	if ( row >= _numlines ) {
		row = _numlines - 1;
	}

	writeCmd(LCD_SETDDRAMADDR | (col + row_offsets[row]));
}

// 40x4Ή 120509
//	I[o[h
void wI2cLcd::setCursor(uint8_t col, uint8_t row, uint8_t area) {
	if(_w_area) {
		if(area > 2) {
			area = 2;
		}
		if(currArea != area) {
			selectArea(area);		// JgGAƈقȂƂ̂ݑM
			currArea = area;
		}
	}
	setCursor(col, row);
}


// 40x4Ή 120509
void wI2cLcd::selectArea(uint8_t area) {
	if(!_w_area) {
		return;
	}
	if(area > 2) {
		area = 2;
	}

	if(currArea != area) {
		currArea = area;	 // GAIϐɐݒ
		// GAIR}hM
		Wire.beginTransmission(slaveAddress);
		Wire.write(0xFF);				// GAIR}h
		Wire.write(area);				// GAԍ 0,1,2
		Wire.endTransmission();
	}
}


void wI2cLcd::noDisplay() {
	_displaycontrol &= ~LCD_DISPLAYON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wI2cLcd::display() {
	_displaycontrol |= LCD_DISPLAYON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}


void wI2cLcd::noCursor() {
	_displaycontrol &= ~LCD_CURSORON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wI2cLcd::cursor() {
	_displaycontrol |= LCD_CURSORON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}


void wI2cLcd::noBlink() {
	_displaycontrol &= ~LCD_BLINKON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wI2cLcd::blink() {
	_displaycontrol |= LCD_BLINKON;
	writeCmd(LCD_DISPLAYCONTROL | _displaycontrol);
}


void wI2cLcd::scrollDisplayLeft(void) {
	writeCmd(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVELEFT);
}
void wI2cLcd::scrollDisplayRight(void) {
	writeCmd(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVERIGHT);
}



void wI2cLcd::leftToRight(void) {
	_displaymode |= LCD_ENTRYLEFT;
	writeCmd(LCD_ENTRYMODESET | _displaymode);
}


void wI2cLcd::rightToLeft(void) {
	_displaymode &= ~LCD_ENTRYLEFT;
	writeCmd(LCD_ENTRYMODESET | _displaymode);
}


void wI2cLcd::autoscroll(void) {
	_displaymode |= LCD_ENTRYSHIFTINCREMENT;
	writeCmd(LCD_ENTRYMODESET | _displaymode);
}


void wI2cLcd::noAutoscroll(void) {
	_displaymode &= ~LCD_ENTRYSHIFTINCREMENT;
	writeCmd(LCD_ENTRYMODESET | _displaymode);
}


void wI2cLcd::createChar(uint8_t location, uint8_t charmap[]) {
	location &= 0x07; // we only have 8 locations 0-7

	uint8_t i;
	writeCmd(LCD_SETCGRAMADDR | (location << 3));
	for (i = 0; i < 8; i++) {
		writeData(charmap[i]);
	}
}


void wI2cLcd::writeCmd(uint8_t cmd) {
	uint8_t rs_flg;

	Wire.beginTransmission(slaveAddress);
	rs_flg = 0x00;
	Wire.write(rs_flg);
	Wire.write(cmd);
	Wire.endTransmission();
}


void wI2cLcd::writeData(uint8_t dat) {
	Wire.beginTransmission(slaveAddress);
	Wire.write(0x80);
	Wire.write(dat);
	Wire.endTransmission();
}


// I[oECh
inline size_t wI2cLcd::write(uint8_t value) {
	writeData(value);
	return 1;
}
